'''
this is a part of the heybuddy project
copyright 2010 jezra lickter http://www.jezra.net
'''
import ConfigParser
import os.path
import pickle
class Configuration:
	def __init__(self,app_name):
		self._name = ""
		self._password = ""
		self.config = ConfigParser.RawConfigParser()
		config_file = ".%s" % (app_name)
		self.file = os.path.join( os.path.expanduser("~"),config_file )
		if os.path.exists( self.file ):
			try:
				self.config.read(self.file)
				self._name = self.config.get('identica','name')
				self._password = self.config.get('identica','password')
			except:
				self.set('identica', 'name', self._name)
				self.set('identica', 'password', self._password)
				pass #bummer
				
	def save(self):
		f = open(self.file,"w")
		self.config.write(f)
		f.close()
	
	def name(self,value=None):
		if value!=None:
			self._name = value
			self.set('identica', 'name', self._name)
		return self._name
		
	def password(self,value=None):
		if value!=None:
			self._password = value
			self.set('identica', 'password', self._password)
		return self._password
	
	def set(self,section,key,value,pickled = False):
		if not self.config.has_section(section) :
			self.config.add_section(section)
		if pickled:
			value = pickle.dumps(value)
		self.config.set(section,key,value)	
		
	def get(self,section,key,pickled=False,default=False):
		try:
			if pickled:
				val = pickle.loads( self.config.get(section,key) )
			else:
				val = self.config.get(section,key)	
		except :
			print "key exceptions %s : %s" % (section,key)
			val = default
		return val
		
	def get_bool_option(self,option):
		try:
			val = self.config.get('options',option)
		except:
			val=False
		if val == 'True':
			val=True
		else:
			val=False
		return val
